diff --git a/scripts/gcc-plugins/size_overflow_plugin/remove_unnecessary_dup.c b/scripts/gcc-plugins/size_overflow_plugin/remove_unnecessary_dup.c
new file mode 100644
index 000000000000..5c268627352e
--- /dev/null
+++ b/scripts/gcc-plugins/size_overflow_plugin/remove_unnecessary_dup.c
@@ -0,0 +1,137 @@
+/*
+ * Copyright 2011-2017 by Emese Revfy <re.emese@gmail.com>
+ * Licensed under the GPL v2
+ *
+ * Homepage:
+ * https://github.com/ephox-gcc-plugins/size_overflow
+ *
+ * Documentation:
+ * http://forums.grsecurity.net/viewtopic.php?f=7&t=3043
+ *
+ * This plugin recomputes expressions of function arguments marked by a size_overflow attribute
+ * with double integer precision (DImode/TImode for 32/64 bit integer types).
+ * The recomputed argument is checked against TYPE_MAX and an event is logged on overflow and the triggering process is killed.
+ *
+ * Usage:
+ * $ make
+ * $ make run
+ */
+
+#include "size_overflow.h"
+
+bool skip_expr_on_double_type(const gassign *stmt)
+{
+	enum tree_code code = gimple_assign_rhs_code(stmt);
+
+	switch (code) {
+	case RSHIFT_EXPR:
+	case TRUNC_DIV_EXPR:
+	case CEIL_DIV_EXPR:
+	case FLOOR_DIV_EXPR:
+	case ROUND_DIV_EXPR:
+	case EXACT_DIV_EXPR:
+	case RDIV_EXPR:
+	case TRUNC_MOD_EXPR:
+	case CEIL_MOD_EXPR:
+	case FLOOR_MOD_EXPR:
+	case ROUND_MOD_EXPR:
+		return true;
+	default:
+		return false;
+	}
+}
+
+void create_up_and_down_cast(struct visited *visited, gassign *use_stmt, tree orig_type, tree rhs)
+{
+	const_tree orig_rhs1;
+	tree down_lhs, new_lhs, dup_type = TREE_TYPE(rhs);
+	const_gimple down_cast, up_cast;
+	gimple_stmt_iterator gsi = gsi_for_stmt(use_stmt);
+
+	down_cast = build_cast_stmt(visited, orig_type, rhs, CREATE_NEW_VAR, &gsi, BEFORE_STMT, false);
+	down_lhs = get_lhs(down_cast);
+
+	gsi = gsi_for_stmt(use_stmt);
+	up_cast = build_cast_stmt(visited, dup_type, down_lhs, CREATE_NEW_VAR, &gsi, BEFORE_STMT, false);
+	new_lhs = get_lhs(up_cast);
+
+	orig_rhs1 = gimple_assign_rhs1(use_stmt);
+	if (operand_equal_p(orig_rhs1, rhs, 0))
+		gimple_assign_set_rhs1(use_stmt, new_lhs);
+	else
+		gimple_assign_set_rhs2(use_stmt, new_lhs);
+	update_stmt(use_stmt);
+
+	pointer_set_insert(visited->my_stmts, up_cast);
+	pointer_set_insert(visited->my_stmts, down_cast);
+	pointer_set_insert(visited->skip_expr_casts, up_cast);
+	pointer_set_insert(visited->skip_expr_casts, down_cast);
+}
+
+static tree get_proper_unsigned_half_type(const_tree node)
+{
+	tree new_type, type;
+
+	gcc_assert(is_size_overflow_type(node));
+
+	type = TREE_TYPE(node);
+	switch (TYPE_MODE(type)) {
+	case HImode:
+		new_type = unsigned_intQI_type_node;
+		break;
+	case SImode:
+		new_type = unsigned_intHI_type_node;
+		break;
+	case DImode:
+		new_type = unsigned_intSI_type_node;
+		break;
+	case TImode:
+		new_type = unsigned_intDI_type_node;
+		break;
+	default:
+		gcc_unreachable();
+	}
+
+	if (TYPE_QUALS(type) != 0)
+		return build_qualified_type(new_type, TYPE_QUALS(type));
+	return new_type;
+}
+
+static void insert_cast_rhs(struct visited *visited, gassign *stmt, tree rhs)
+{
+	tree type;
+
+	if (rhs == NULL_TREE)
+		return;
+	if (!is_size_overflow_type(rhs))
+		return;
+
+	type = get_proper_unsigned_half_type(rhs);
+	if (is_gimple_constant(rhs))
+		return;
+	create_up_and_down_cast(visited, stmt, type, rhs);
+}
+
+static void insert_cast(struct visited *visited, gassign *stmt, tree rhs)
+{
+	if (LONG_TYPE_SIZE == GET_MODE_BITSIZE(SImode) && !is_size_overflow_type(rhs))
+		return;
+	gcc_assert(is_size_overflow_type(rhs));
+	insert_cast_rhs(visited, stmt, rhs);
+}
+
+void insert_cast_expr(struct visited *visited, gassign *stmt, enum intentional_overflow_type type)
+{
+	tree rhs1, rhs2;
+
+	if (type == NO_INTENTIONAL_OVERFLOW || type == RHS1_INTENTIONAL_OVERFLOW) {
+		rhs1 = gimple_assign_rhs1(stmt);
+		insert_cast(visited, stmt, rhs1);
+	}
+
+	if (type == NO_INTENTIONAL_OVERFLOW || type == RHS2_INTENTIONAL_OVERFLOW) {
+		rhs2 = gimple_assign_rhs2(stmt);
+		insert_cast(visited, stmt, rhs2);
+	}
+}
+
diff --git a/scripts/gcc-plugins/size_overflow_plugin/size_overflow.h b/scripts/gcc-plugins/size_overflow_plugin/size_overflow.h
new file mode 100644
index 000000000000..6ab03351b800
--- /dev/null
+++ b/scripts/gcc-plugins/size_overflow_plugin/size_overflow.h
@@ -0,0 +1,345 @@
+#ifndef SIZE_OVERFLOW_H
+#define SIZE_OVERFLOW_H
+
+#define CREATE_NEW_VAR NULL_TREE
+#define MAX_PARAM 31
+#define CANNOT_FIND_ARG 32
+#define NONE_ARGNUM 32
+
+#define BEFORE_STMT true
+#define AFTER_STMT false
+
+#define TURN_OFF_ASM_STR "# size_overflow MARK_TURN_OFF "
+#define YES_ASM_STR "# size_overflow MARK_YES "
+#define END_INTENTIONAL_ASM_STR "# size_overflow MARK_END_INTENTIONAL "
+#define SO_ASM_STR "# size_overflow "
+#define OK_ASM_STR "# size_overflow MARK_NO"
+
+#define FUNCTION_PTR_P(node) \
+	(TREE_CODE(TREE_TYPE(node)) == POINTER_TYPE && (TREE_CODE(TREE_TYPE(TREE_TYPE(node))) == FUNCTION_TYPE || TREE_CODE(TREE_TYPE(TREE_TYPE(node))) == METHOD_TYPE))
+
+#define CODES_LIMIT 32
+
+#define GLOBAL_NIFN_LEN 65536
+#define NO_HASH 65537
+
+#define SIZE_OVERFLOW true
+#define DISABLE_SIZE_OVERFLOW false
+
+#include "gcc-common.h"
+
+#include <string.h>
+#include <limits.h>
+
+enum intentional_mark {
+	MARK_NO, MARK_YES, MARK_END_INTENTIONAL, MARK_TURN_OFF
+};
+
+enum intentional_overflow_type {
+	NO_INTENTIONAL_OVERFLOW, RHS1_INTENTIONAL_OVERFLOW, RHS2_INTENTIONAL_OVERFLOW
+};
+
+enum size_overflow_mark {
+	NO_SO_MARK, YES_SO_MARK, ASM_STMT_SO_MARK
+};
+
+struct decl_hash {
+	size_t tree_codes_len;
+	unsigned char tree_codes[CODES_LIMIT];
+	const_tree decl;
+	const char *context;
+	unsigned int hash;
+	const char *fn_name;
+};
+
+struct next_interesting_function;
+typedef struct next_interesting_function *  next_interesting_function_t;
+
+struct interesting_stmts;
+typedef struct interesting_stmts * interesting_stmts_t;
+
+enum based_decl {
+	SO_FUNCTION, SO_VAR, SO_FIELD, SO_FUNCTION_POINTER, SO_AUX, SO_DISABLE, SO_NONE
+};
+
+// Store data associated with the next_interesting_function_t entry
+struct fn_raw_data
+{
+	const char *decl_str;
+	tree decl;
+	const char *context;
+	unsigned int hash;
+	unsigned int num;
+	enum size_overflow_mark marked;
+	enum based_decl based_decl;
+	const char *orig_decl_str;
+	unsigned int orig_num;
+};
+
+#if BUILDING_GCC_VERSION <= 4007
+DEF_VEC_P(next_interesting_function_t);
+DEF_VEC_ALLOC_P(next_interesting_function_t, heap);
+#endif
+
+#if BUILDING_GCC_VERSION >= 5000
+typedef struct hash_set<const_gimple> gimple_set;
+
+static inline bool pointer_set_insert(gimple_set *visited, const_gimple stmt)
+{
+	return visited->add(stmt);
+}
+
+static inline bool pointer_set_contains(gimple_set *visited, const_gimple stmt)
+{
+	return visited->contains(stmt);
+}
+
+static inline gimple_set* pointer_set_create(void)
+{
+	return new hash_set<const_gimple>;
+}
+
+static inline void pointer_set_destroy(gimple_set *visited)
+{
+	delete visited;
+}
+
+typedef struct hash_set<next_interesting_function_t> next_interesting_function_set;
+
+static inline bool pointer_set_insert(next_interesting_function_set *visited, next_interesting_function_t node)
+{
+	return visited->add(node);
+}
+
+static inline bool pointer_set_contains(next_interesting_function_set *visited, next_interesting_function_t node)
+{
+	return visited->contains(node);
+}
+
+static inline next_interesting_function_set *next_interesting_function_pointer_set_create(void)
+{
+	return new hash_set<next_interesting_function_t>;
+}
+
+static inline void pointer_set_destroy(next_interesting_function_set *visited)
+{
+	delete visited;
+}
+#else
+typedef struct pointer_set_t gimple_set;
+typedef struct pointer_set_t next_interesting_function_set;
+
+static inline next_interesting_function_set *next_interesting_function_pointer_set_create(void)
+{
+	return pointer_set_create();
+}
+#endif
+
+struct visited {
+	gimple_set *stmts;
+	gimple_set *my_stmts;
+	gimple_set *skip_expr_casts;
+	gimple_set *no_cast_check;
+};
+
+/*
+ *  * children: callers with data flow into the integer parameter of decl
+ *  * decl_name: name of the function or the field
+ *  * context: the containing type name for a function pointer (or "fielddecl" if the type has no name), otherwise either "vardecl" or "fndecl"
+ *  * hash: hash num of the function
+ *  * num: parameter number (1-31) or return value (0)
+ *  * marked: determines whether to duplicate stmts and/or look for missing hashtable entries
+ *  * orig_next_node: pointer to the originally cloned function
+ */
+
+struct next_interesting_function {
+	next_interesting_function_t next;
+#if BUILDING_GCC_VERSION <= 4007
+	VEC(next_interesting_function_t, heap) *children;
+#else
+	vec<next_interesting_function_t, va_heap, vl_embed> *children;
+#endif
+	const char *decl_name;
+	const char *context;
+	enum based_decl based_decl;
+	unsigned int hash;
+	unsigned int num;
+	enum size_overflow_mark marked;
+	next_interesting_function_t orig_next_node;
+};
+
+// size_overflow_plugin.c
+extern tree report_size_overflow_decl;
+extern tree size_overflow_type_HI;
+extern tree size_overflow_type_SI;
+extern tree size_overflow_type_DI;
+extern tree size_overflow_type_TI;
+// command line options
+extern bool check_fields, check_fns, check_fnptrs, check_vars;
+
+
+// size_overflow_plugin_hash.c
+struct size_overflow_hash {
+	const struct size_overflow_hash * const next;
+	const char * const name;
+	const char * const context;
+	const unsigned int param;
+};
+
+extern const char *get_orig_decl_name(const_tree decl);
+extern bool is_size_overflow_asm(const_gimple stmt);
+extern void print_missing_function(next_interesting_function_t node);
+extern const struct size_overflow_hash *get_size_overflow_hash_entry(struct fn_raw_data *raw_data);
+extern const struct size_overflow_hash *get_size_overflow_hash_entry_tree(struct fn_raw_data *raw_data, bool hash_table);
+extern unsigned int find_arg_number_tree(const_tree arg, const_tree func);
+extern unsigned int get_decl_hash(const_tree decl, const char *decl_name);
+extern const char *get_based_decl_str(enum based_decl based_decl);
+extern void initialize_raw_data(struct fn_raw_data *raw_data);
+
+
+// intentional_overflow.c
+extern enum intentional_mark get_intentional_attr_type(const_tree node);
+extern tree get_size_overflow_asm_input(const gasm *stmt);
+extern enum intentional_mark check_intentional_size_overflow_asm_and_attribute(const_tree var);
+extern bool is_size_overflow_insert_check_asm(const gasm *stmt);
+extern enum intentional_mark check_intentional_attribute(const_gimple stmt, unsigned int argnum);
+extern enum intentional_mark get_so_asm_type(const_gimple stmt);
+extern const_tree get_attribute(const char* attr_name, const_tree decl);
+extern bool is_a_cast_and_const_overflow(const_tree no_const_rhs);
+extern bool is_const_plus_unsigned_signed_truncation(const_tree lhs);
+extern bool is_a_constant_overflow(const gassign *stmt, const_tree rhs);
+extern tree handle_intentional_overflow(interesting_stmts_t expand_from, bool check_overflow, gassign *stmt, tree change_rhs, tree new_rhs2);
+extern tree handle_integer_truncation(interesting_stmts_t expand_from, const_tree lhs);
+extern bool is_a_neg_overflow(const gassign *stmt, const_tree rhs);
+extern enum intentional_overflow_type add_mul_intentional_overflow(const gassign *stmt);
+extern void unsigned_signed_cast_intentional_overflow(struct visited *visited, gassign *stmt);
+extern bool neg_short_add_intentional_overflow(gassign *stmt);
+extern bool is_bitfield_unnamed_cast(const_tree decl, gassign *assign);
+extern bool uconst_neg_intentional_overflow(const gassign *stmt);
+extern bool short_or_neg_const_ushort(gassign *stmt);
+
+
+// insert_size_overflow_asm.c
+#if BUILDING_GCC_VERSION >= 4009
+extern opt_pass *make_insert_size_overflow_asm_pass(void);
+#else
+extern struct opt_pass *make_insert_size_overflow_asm_pass(void);
+#endif
+extern bool search_interesting_args(tree fndecl, bool *argnums);
+
+
+// size_overflow_misc.c
+extern bool is_vararg(const_tree fn, unsigned int num);
+extern tree get_ref_field(const_tree ref);
+extern unsigned int get_correct_argnum_fndecl(const_tree fndecl, const_tree correct_argnum_of_fndecl, unsigned int num);
+extern const char *get_type_name_from_field(const_tree field_decl);
+extern void set_dominance_info(void);
+extern void unset_dominance_info(void);
+extern tree get_interesting_orig_fndecl_from_stmt(const gcall *stmt);
+extern tree get_orig_fndecl(const_tree clone_fndecl);
+extern unsigned int get_correct_argnum(const_tree decl, const_tree correct_argnum_of_decl, unsigned int argnum);
+extern bool is_valid_cgraph_node(struct cgraph_node *node);
+extern void set_current_function_decl(tree fndecl);
+extern void unset_current_function_decl(void);
+extern gimple get_def_stmt(const_tree node);
+extern tree create_new_var(tree type);
+extern gimple build_cast_stmt(struct visited *visited, tree dst_type, tree rhs, tree lhs, gimple_stmt_iterator *gsi, bool before, bool force);
+extern bool skip_types(const_tree var);
+extern tree cast_a_tree(tree type, tree var);
+extern bool is_size_overflow_type(const_tree var);
+extern bool made_by_compiler(const_tree decl);
+extern gimple get_fnptr_def_stmt(const_tree fn_ptr);
+extern tree get_lhs(const_gimple stmt);
+
+
+// size_overflow_transform.c
+struct interesting_stmts {
+	struct interesting_stmts *next;
+	next_interesting_function_t next_node;
+	gimple first_stmt;
+	tree orig_node;
+	unsigned int num;
+	struct visited *visited;
+};
+
+extern unsigned int size_overflow_function_transform(struct cgraph_node *node);
+extern tree handle_fnptr_assign(const_gimple stmt);
+
+
+// size_overflow_transform_core.c
+extern tree cast_to_new_size_overflow_type(struct visited *visited, gimple stmt, tree rhs, tree size_overflow_type, bool before);
+extern tree get_size_overflow_type(struct visited *visited, const_gimple stmt, const_tree node);
+extern tree expand(interesting_stmts_t expand_from, tree lhs);
+extern void check_size_overflow(interesting_stmts_t expand_from, gimple stmt, tree size_overflow_type, tree cast_rhs, tree rhs, bool before);
+extern tree dup_assign(struct visited *visited, gassign *oldstmt, const_tree node, tree rhs1, tree rhs2, tree __unused rhs3);
+extern tree create_assign(struct visited *visited, gimple oldstmt, tree rhs1, bool before);
+
+
+// remove_unnecessary_dup.c
+extern struct opt_pass *make_remove_unnecessary_dup_pass(void);
+extern void insert_cast_expr(struct visited *visited, gassign *stmt, enum intentional_overflow_type type);
+extern bool skip_expr_on_double_type(const gassign *stmt);
+extern void create_up_and_down_cast(struct visited *visited, gassign *use_stmt, tree orig_type, tree rhs);
+
+
+// size_overflow_ipa.c
+struct walk_use_def_data {
+	next_interesting_function_t parent;
+	next_interesting_function_t next_cnodes_head;
+	gimple_set *visited;
+};
+
+extern const char* get_decl_context(const_tree decl);
+extern void add_to_global_next_interesting_function(next_interesting_function_t new_entry);
+extern bool has_next_interesting_function_vec(next_interesting_function_t target, next_interesting_function_t next_node);
+extern void push_child(next_interesting_function_t parent, next_interesting_function_t child);
+extern struct cgraph_node *get_cnode(const_tree fndecl);
+extern next_interesting_function_t global_next_interesting_function[GLOBAL_NIFN_LEN];
+extern next_interesting_function_t get_global_next_interesting_function_entry(struct fn_raw_data *raw_data);
+extern next_interesting_function_t get_global_next_interesting_function_entry_with_hash(struct fn_raw_data *raw_data);
+extern void size_overflow_register_hooks(void);
+#if BUILDING_GCC_VERSION >= 4009
+extern opt_pass *make_size_overflow_pass(void);
+#else
+extern struct opt_pass *make_size_overflow_pass(void);
+#endif
+extern void size_overflow_node_removal_hook(struct cgraph_node *node, void *data);
+extern next_interesting_function_t get_and_create_next_node_from_global_next_nodes(struct fn_raw_data *raw_data, next_interesting_function_t orig_next_node);
+extern next_interesting_function_t create_new_next_interesting_decl(struct fn_raw_data *raw_data, next_interesting_function_t orig_next_node);
+extern next_interesting_function_t create_new_next_interesting_entry(struct fn_raw_data *raw_data, next_interesting_function_t orig_next_node);
+
+
+// size_overflow_lto.c
+extern void size_overflow_read_summary(void);
+extern void size_overflow_read_optimization_summary(void);
+#if BUILDING_GCC_VERSION >= 4008
+extern void size_overflow_write_summary(void);
+extern void size_overflow_write_optimization_summary(void);
+#elif BUILDING_GCC_VERSION >= 4006
+extern void size_overflow_write_summary(cgraph_node_set set, varpool_node_set vset);
+extern void size_overflow_write_optimization_summary(cgraph_node_set set, varpool_node_set vset);
+#else
+extern void size_overflow_write_summary(cgraph_node_set set);
+extern void size_overflow_write_optimization_summary(cgraph_node_set set);
+#endif
+
+// size_overflow_fnptrs.c
+extern void handle_function_ptr_ret(struct walk_use_def_data *use_def_data, const_tree fn_ptr);
+extern void check_local_variables(next_interesting_function_t next_node);
+extern void check_global_variables(next_interesting_function_t cur_global);
+extern next_interesting_function_t get_and_create_next_node_from_global_next_nodes_fnptr(const_tree fn_ptr, struct fn_raw_data *raw_data);
+
+
+// size_overflow_debug.c
+extern void __unused print_intentional_mark(enum intentional_mark mark);
+extern unsigned int __unused size_overflow_dump_function(FILE *file, struct cgraph_node *node);
+extern void __unused print_next_interesting_functions_chain(next_interesting_function_t head, bool only_this);
+extern void __unused print_global_next_interesting_functions(void);
+extern void __unused print_children_chain_list(next_interesting_function_t next_node);
+extern void __unused print_all_next_node_children_chain_list(next_interesting_function_t next_node);
+extern const char * __unused print_so_mark_name(enum size_overflow_mark mark);
+extern const char * __unused print_intentional_mark_name(enum intentional_mark mark);
+extern void __unused print_next_interesting_function(next_interesting_function_t node);
+extern void __unused print_raw_data(struct fn_raw_data *data);
+
+#endif
diff --git a/scripts/gcc-plugins/size_overflow_plugin/size_overflow_debug.c b/scripts/gcc-plugins/size_overflow_plugin/size_overflow_debug.c
new file mode 100644
index 000000000000..bae3ee7ade88
--- /dev/null
+++ b/scripts/gcc-plugins/size_overflow_plugin/size_overflow_debug.c
@@ -0,0 +1,201 @@
+/*
+ * Copyright 2011-2017 by Emese Revfy <re.emese@gmail.com>
+ * Licensed under the GPL v2
+ *
+ * Homepage:
+ * https://github.com/ephox-gcc-plugins/size_overflow
+ *
+ * Documentation:
+ * http://forums.grsecurity.net/viewtopic.php?f=7&t=3043
+ *
+ * This plugin recomputes expressions of function arguments marked by a size_overflow attribute
+ * with double integer precision (DImode/TImode for 32/64 bit integer types).
+ * The recomputed argument is checked against TYPE_MAX and an event is logged on overflow and the triggering process is killed.
+ *
+ * Usage:
+ * $ make
+ * $ make run
+ */
+
+#include "size_overflow.h"
+
+void __unused print_intentional_mark(enum intentional_mark mark)
+{
+	fprintf(stderr, "intentional mark: ");
+	switch (mark) {
+	case MARK_NO:
+		fprintf(stderr, "mark_no\n");
+		break;
+	case MARK_YES:
+		fprintf(stderr, "mark_yes\n");
+		break;
+	case MARK_TURN_OFF:
+		fprintf(stderr, "mark_turn_off\n");
+		break;
+	case MARK_END_INTENTIONAL:
+		fprintf(stderr, "mark_end_intentional\n");
+		break;
+	}
+}
+
+unsigned int __unused size_overflow_dump_function(FILE *file, struct cgraph_node *node)
+{
+	basic_block bb;
+
+	fprintf(file, "dump_function function_name: %s\n", cgraph_node_name(node));
+
+	fprintf(file, "\nstmts:\n");
+	FOR_EACH_BB_FN(bb, DECL_STRUCT_FUNCTION(NODE_DECL(node))) {
+		gimple_stmt_iterator si;
+
+		fprintf(file, "<bb %u>:\n", bb->index);
+		for (si = gsi_start_phis(bb); !gsi_end_p(si); gsi_next(&si))
+			print_gimple_stmt(file, gsi_stmt(si), 0, TDF_VOPS|TDF_MEMSYMS);
+		for (si = gsi_start_bb(bb); !gsi_end_p(si); gsi_next(&si))
+			print_gimple_stmt(file, gsi_stmt(si), 0, TDF_VOPS|TDF_MEMSYMS);
+		fprintf(file, "\n");
+	}
+
+	fprintf(file, "---------------------------------\n");
+
+	return 0;
+}
+
+void __unused print_next_interesting_function(next_interesting_function_t node)
+{
+	unsigned int i, children_len;
+	next_interesting_function_t cur;
+
+	if (!node)
+		return;
+
+#if BUILDING_GCC_VERSION <= 4007
+	if (VEC_empty(next_interesting_function_t, node->children))
+		children_len = 0;
+	else
+		children_len = VEC_length(next_interesting_function_t, node->children);
+#else
+	children_len = vec_safe_length(node->children);
+#endif
+
+	fprintf(stderr, "print_next_interesting_function: ptr: %p, ", node);
+	fprintf(stderr, "decl_name: %s, based_decl: %s, ", node->decl_name, get_based_decl_str(node->based_decl));
+
+	fprintf(stderr, "num: %u marked: %s context: %s children len: %u\n", node->num, print_so_mark_name(node->marked), node->context, children_len);
+#if BUILDING_GCC_VERSION <= 4007
+	if (VEC_empty(next_interesting_function_t, node->children))
+		return;
+	FOR_EACH_VEC_ELT(next_interesting_function_t, node->children, i, cur) {
+#else
+	FOR_EACH_VEC_SAFE_ELT(node->children, i, cur) {
+#endif
+		fprintf(stderr, "\t%u. child: %s %u %p marked: %s context: %s\n", i + 1, cur->decl_name, cur->num, cur, print_so_mark_name(cur->marked), cur->context);
+	}
+}
+
+// Dump the full next_interesting_function_t list for parsing by print_dependecy.py
+void __unused print_next_interesting_functions_chain(next_interesting_function_t head, bool only_this)
+{
+	next_interesting_function_t cur;
+	unsigned int len;
+
+	fprintf(stderr, "----------------------\nnext_interesting_function_t head: %p\n", head);
+	for (cur = head, len = 0; cur; cur = cur->next, len++) {
+		fprintf(stderr, "%u. ", len + 1);
+		print_next_interesting_function(cur);
+
+		fprintf(stderr, "+++++ has orig node: %p +++++\n", cur->orig_next_node);
+		print_next_interesting_function(cur->orig_next_node);
+
+		if (only_this)
+			break;
+	}
+
+	fprintf(stderr, "len: %u\n----------------------\n\n\n", len + 1);
+}
+
+void __unused print_global_next_interesting_functions(void)
+{
+	unsigned int i;
+
+	fprintf(stderr, "----------------------\nprint_global_next_interesting_functions:\n----------------------\n");
+	for (i = 0; i < GLOBAL_NIFN_LEN; i++) {
+		if (!global_next_interesting_function[i])
+			continue;
+		fprintf(stderr, "hash: %u\n", i);
+		print_next_interesting_functions_chain(global_next_interesting_function[i], false);
+	}
+	fprintf(stderr, "----------------------\n\n");
+}
+
+// Dump the information related to the specified next_interesting_function_t for parsing by print_dependecy.py
+void __unused print_children_chain_list(next_interesting_function_t next_node)
+{
+	next_interesting_function_t cur;
+	unsigned int i;
+
+#if BUILDING_GCC_VERSION <= 4007
+	if (VEC_empty(next_interesting_function_t, next_node->children))
+		return;
+	FOR_EACH_VEC_ELT(next_interesting_function_t, next_node->children, i, cur) {
+#else
+	FOR_EACH_VEC_SAFE_ELT(next_node->children, i, cur) {
+#endif
+		fprintf(stderr, "parent: %s %u (marked: %s) child: %s %u\n", next_node->decl_name, next_node->num, print_so_mark_name(next_node->marked), cur->decl_name, cur->num);
+		print_children_chain_list(cur);
+	}
+}
+
+void __unused print_all_next_node_children_chain_list(next_interesting_function_t head)
+{
+	next_interesting_function_t cur;
+
+	for (cur = head; cur; cur = cur->next) {
+#if BUILDING_GCC_VERSION <= 4007
+		if (VEC_empty(next_interesting_function_t, cur->children))
+#else
+		if (vec_safe_length(cur->children) == 0)
+#endif
+			continue;
+		fprintf(stderr, "############ START ############\n");
+		print_children_chain_list(cur);
+		fprintf(stderr, "############ END ############\n");
+	}
+}
+
+const char * __unused print_intentional_mark_name(enum intentional_mark mark)
+{
+	switch(mark) {
+	case MARK_NO:
+		return "mark no";
+	case MARK_YES:
+		return "mark yes";
+	case MARK_END_INTENTIONAL:
+		return "mark end intetional";
+	case MARK_TURN_OFF:
+		return "mark turn off";
+	}
+
+	gcc_unreachable();
+}
+
+const char * __unused print_so_mark_name(enum size_overflow_mark mark)
+{
+	switch(mark) {
+	case ASM_STMT_SO_MARK:
+		return "asm_stmt_so_mark";
+	case YES_SO_MARK:
+		return "yes_so_mark";
+	case NO_SO_MARK:
+		return "no_so_mark";
+	}
+
+	gcc_unreachable();
+}
+
+void __unused print_raw_data(struct fn_raw_data *data)
+{
+	fprintf(stderr, "decl_str: %s, context: %s, num: %u, hash: %u\ndecl:\n", data->decl_str ? data->decl_str : "NULL", data->context ? data->context : "NULL", data->num, data->hash);
+	debug_tree(data->decl);
+	fprintf(stderr, "marked: %s, based_decl: %s\norig_decl_str: %s, orig_num: %u\n", print_so_mark_name(data->marked), get_based_decl_str(data->based_decl), data->orig_decl_str? data->orig_decl_str : "NULL", data->orig_num);
+}
